# eric7.Graphics.GraphicsUtilities

Module implementing some graphical utility functions.

### Global Attributes

None

### Classes

RecursionError | Unable to calculate result because of recursive structure.

### Functions

_buildChildrenLists | Function to build up parent - child relationships.
sort | Function to sort widgets topographically.

## RecursionError

Unable to calculate result because of recursive structure.

### Derived from

OverflowError, ValueError

### Class Attributes

None

### Class Methods

None

### Methods

None

### Static Methods

None

Up

## _buildChildrenLists

_buildChildrenLists(routes)

Function to build up parent - child relationships.

Taken from Boa Constructor.

routes (list of tuple of (str, str))
  list of routes between nodes

Return:
  dictionary of child and dictionary of parent relationships

Return Type:
  tuple of (dict, dict)

Up

## sort

sort(nodes, routes, noRecursion=False)

Function to sort widgets topographically.

Passed a list of nodes and a list of source, dest routes, it attempts to create a list of stages, where each sub list is one stage in a process.

The algorithm was taken from Boa Constructor.

nodes (str)
  list of nodes to be sorted
routes (list of tuple of (str, str))
  list of routes between the nodes
noRecursion (bool)
  flag indicating, if recursion errors should be raised

Return:
  list of stages

Return Type:
  list of lists of str

Raises RecursionError:
  a recursion error was detected

Up